/*
 * Copyright (C) 2007 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.harmony.crypto.tests.javax.crypto;

import junit.framework.Test;
import junit.framework.TestSuite;

/**
 * This is autogenerated source file. Includes tests for package org.apache.harmony.crypto.tests.javax.crypto;
 */

public class AllTests {

    public static void main(String[] args) {
        junit.textui.TestRunner.run(AllTests.suite());
    }

    public static Test suite() {
        TestSuite suite = tests.TestSuiteFactory.createTestSuite("All tests for package org.apache.harmony.crypto.tests.javax.crypto;");
        // $JUnit-BEGIN$

        suite.addTestSuite(BadPaddingExceptionTest.class);
        suite.addTestSuite(CipherInputStream1Test.class);
        suite.addTestSuite(CipherInputStreamTest.class);
        suite.addTestSuite(CipherOutputStream1Test.class);
        suite.addTestSuite(CipherOutputStreamTest.class);
        suite.addTestSuite(CipherSpiTest.class);
        suite.addTestSuite(CipherTest.class);
        suite.addTestSuite(EncryptedPrivateKeyInfoTest.class);
        suite.addTestSuite(ExemptionMechanismExceptionTest.class);
        suite.addTestSuite(ExemptionMechanismSpiTest.class);
        suite.addTestSuite(ExemptionMechanismTest.class);
        suite.addTestSuite(IllegalBlockSizeExceptionTest.class);
        suite.addTestSuite(KeyAgreementSpiTest.class);
        suite.addTestSuite(KeyAgreementTest.class);
        suite.addTestSuite(KeyGeneratorSpiTest.class);
        suite.addTestSuite(KeyGeneratorTest.class);
        suite.addTestSuite(MacSpiTest.class);
        suite.addTestSuite(MacTest.class);
        suite.addTestSuite(NoSuchPaddingExceptionTest.class);
        suite.addTestSuite(NullCipherTest.class);
        suite.addTestSuite(SealedObjectTest.class);
        suite.addTestSuite(SecretKeyFactorySpiTest.class);
        suite.addTestSuite(SecretKeyFactoryTest.class);
        suite.addTestSuite(SecretKeyTest.class);
        suite.addTestSuite(ShortBufferExceptionTest.class);

        // $JUnit-END$
        return suite;
    }
}
